
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>jQuery 1.9.1源码分析系列（十五）动画处理之缓动动画核心Tween_jquery / iVAN</title>

    <meta name="description" content="jQuery 1.9.1源码分析系列（十五）动画处理之缓动动画核心Tween_jquery 在jQuery内部函数Animation中调用到了createTweens()来创建缓动动画组,创建完成后的结果为: 可以看到上面的缓动动画组有四个原子动画组成.每一个原子动画的信息都包含在里面了. 仔细查看createTweens函数,实际上就是遍历调用了tweeners [&quot;*&quot;]的数组中的函数(实际上就只有一个元素). function createTweens( animation, props ) { jQuery.each( props, function( pr ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">jQuery 1.9.1源码分析系列（十五）动画处理之缓动动画核心Tween_jquery</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>在jQuery内部函数Animation中调用到了createTweens（）来创建缓动动画组，创建完成后的结果为：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTIwMzEwNTU0ODM5LnBuZw==.jpg"></p>
<p>　　可以看到上面的缓动动画组有四个原子动画组成。每一个原子动画的信息都包含在里面了。</p>
<p>　　仔细查看createTweens函数，实际上就是遍历调用了tweeners ["*"]的数组中的函数（实际上就只有一个元素）。</p>
<pre>
  function createTweens( animation, props ) {
    jQuery.each( props, function( prop, value ) {
      var collection = ( tweeners[ prop ] || [] ).concat( tweeners[ "*" ] ),
      index = 0,
      length = collection.length;
      for ( ; index &lt; length; index++ ) {
        if ( collection[ index ].call( animation, prop, value ) ) {
          // we're done with this property
          return;
        }
      }
    });
  } </pre>
<p>　　再次查看这个tweeners ["*"][0]函数，主要代码如下</p>
<pre>
function( prop, value ) {
  var end, unit,
  //根据css特征值获取缓动动画结构
  tween = this.createTween( prop, value ),
  parts = rfxnum.exec( value ),
  target = tween.cur(),
  start = +target || 0,
  scale = 1,
  maxIterations = 20;
  if ( parts ) {
    end = +parts[2];
    unit = parts[3] || ( jQuery.cssNumber[ prop ] ? "" : "px" );
    //非像素单位的属性
    if ( unit !== "px" &amp;&amp; start ) {
      // 从一个非零起点开始迭代，
      //对于当前属性，如果它使用相同的单位这一过程将是微不足道
      // 后备为end，或一个简单的常量
      start = jQuery.css( tween.elem, prop, true ) || end || 1;
      do {
        //如果前一次迭代为零，加倍，直到我们得到*东西*
        //使用字符串倍增因子，所以我们不会偶然看到scale不改变
        scale = scale || ".5";
        // 调整和运行
        start = start / scale;
        jQuery.style( tween.elem, prop, start + unit );
        // 更新scale, 默认0或NaN从tween.cur()获取
        // 跳出循环，如果scale不变或完成时, 或者我们已经觉得已经足够了
      } while ( scale !== (scale = tween.cur() / target) &amp;&amp; scale !== 1 &amp;&amp; --maxIterations );
    }
    tween.unit = unit;
    tween.start = start;
    //如果提供了+=/-=记号，表示我们正在做一个相对的动画
    tween.end = parts[1] ? start + ( parts[1] + 1 ) * end : end;
    }
    return tween;
  }]
}; </pre>
<p>　　可以看出除了hide/show两种动画外的其他动画都经过tweeners ["*"][0]这个函数封装了动画组。其中有几个关键的数组start/end/unit。特别是对非像素单位的动画start值获取费了一番功夫。</p>
<p>　　还有一个比较关键的地方是都用了this.createTween获取单个css特征的基础的动画特征。而animation. createTween中直接调用jQuery.Tween来处理。接下来我们详解之。</p>
<p>a.jQuery.Tween</p>
<p>--------------------------------------------------------------------------------</p>
<p>　　jQuery.Tween的结构和jQuery类似</p>
<pre>
function Tween( elem, options, prop, end, easing ) {
  return new Tween.prototype.init( elem, options, prop, end, easing );
}
jQuery.Tween = Tween;
Tween.prototype = {
  constructor: Tween,
  init: function( elem, options, prop, end, easing, unit ) {
    this.elem = elem;
    this.prop = prop;
    this.easing = easing || "swing";
    this.options = options;
    this.start = this.now = this.cur();
    this.end = end;
    this.unit = unit || ( jQuery.cssNumber[ prop ] ? "" : "px" );
  },
  cur: function() {...},
  run: function( percent ) {...}
};
Tween.prototype.init.prototype = Tween.prototype; </pre>
<p>　　是不是有一种很熟悉的赶脚。</p>
<p>　　里面cur函数用来获取当前的css特征值</p>
<pre>
cur: function() {
  var hooks = Tween.propHooks[ this.prop ];

  return hooks &amp;&amp; hooks.get ?
  hooks.get( this ) :
  Tween.propHooks._default.get( this );
}, </pre>
<p>　　而run函数则会在每个动画时间点上对正在进行的动画的每个特征值进行处理。</p>
<p>　　主要是两个步骤：</p>
<p>　　<strong>1.计算动画当前进度pos和动画当前位置now</strong></p>
<pre>
//如果有动画时长则使用jQuery.easing计算出缓动动画进度eased，否则进度eased为percent
//并根据进度得到当前动画位置now
if ( this.options.duration ) {
  this.pos = eased = jQuery.easing[ this.easing ](
    percent, this.options.duration * percent, 0, 1, this.options.duration
    );
} else {
  this.pos = eased = percent;
}
this.now = ( this.end - this.start ) * eased + this.start;</pre>
<p><strong>　　2.根据当前进度情况设置css特征值<br /></strong></p>
<pre>
//设置css特征值
if ( hooks &amp;&amp; hooks.set ) {
  hooks.set( this );
} else {
  Tween.propHooks._default.set( this );
}
return this; </pre>
<p>　　可见生成缓动动画这一步处理才是整个动画的核心：</p>
<p>　　创建缓动动画组，每一个原子动画都包含了每一个原子css属性动画的各种必要参数以及动画函数</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE1MTIwMzEwNTU0ODQyLnBuZw==.jpg"></p>
<p>　　不同的是hide/show直接在defaultPrefilter中创建了这个缓动动画组（所有的属性都默认是px单位），其他的动画在调用createTweens时创建缓动动画组。</p>
<p>　　还记不记得在创建动画的时候有个tick函数，这个tick函数会在每隔一个步长的时间调用一次</p>
<pre>
   tick = function() {
      ...
        length = animation.tweens.length;
      for ( ; index &lt; length ; index++ ) {
        animation.tweens[ index ].run( percent );
      }
　　　　　　　...
    } </pre>
<p>　　看到没，每一个原子动画有自己的run函数来执行自己的动画，这在创建缓动动画组的时候就建好了的。</p>
<p>好了，整理一下动画的整个核心流程：</p>
<p>　　1.先根据参数调用jQuery.speed获取动画相关参数，得到一个类似如下的对象；并且生成动画执行函数doAnimation使用.queue压入队列并马上执行</p>
<pre>
opt = {
    complete: fnction(){...},//动画执行完成的回调
    duration: 400,//动画执行时长
    easing: "swing",//动画效果
    queue: "fx",//动画队列
    old: false/fnction(){...},
} </pre>
<p>　　2.doAnimation中调用创建一个延时对象，使用延时对象的promise方法构造一个动画对象animation（延时对象+动画特征列表），最后给animation添加动画执行完成后的回调函数。</p>
<p>　　3.调用jQuery内部函数proFilter修正css特征名以便能被当前浏览器识别，并将某些复合css特征分解（比如padding分解成paddingTop / Right/ Bottom/ Left）.</p>
<p>　　4.调用jQuery内部函数defaultPrefilter做动画能够正常运行前提条件修正：比如对height/width动画display和overflow需要特定的值。特别需要注意的是</p>
<p>对于show/hide动画，在之前就调用genFx将需要执行动画的css特征提取了出来，在defaultPrefilter函数里直接调用动画对象animation.createTween给每一个CSS动画属性添加对应的缓动动画对象（包括动画参数和动画函数如run）压入缓动动画组animation.tweens中</p>
<p>　　5.调用jQuery内部函数createTweens将除开show/hide之外的动画每一个css动画特征使用animation.createTween创建缓动动画对象（包括动画参数和动画函数如run），压入缓动动画组animation.tweens中</p>
<p>　　6.启动动画计时，在每个时间点上执行tick函数来给相应的css特征值设置运动值。</p>
<p>　　其中css特征值运动的进度百分比是</p>
<pre>
remaining = Math.max( 0, animation.startTime + animation.duration - currentTime ),
temp = remaining / animation.duration || 0,
percent = 1 - temp</pre>
<p>　　得到的percent是符合时间规律的。代入这个percent设置准确的css特征值，以刷新动画显示。</p>
<p>　　8.动画完成后调用动画完成回调。</p>
<p>关于小编给大家分享的jQuery 1.9.1源码分析系列（十五）动画处理之缓动动画核心Tween 全部内容就到此结束了，有问题欢迎给我留言我会在第一时间和大家取得联系的。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索jquery1.9.1<br />
                                    tween动画<br />
                                    as3 tweenlite 缓动、tween缓动、js tween 缓动、tweenlite 缓动、jquery缓动效果，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-07 03:02:49</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/tween%e5%8a%a8%e7%94%bb/" title="tween动画">tween动画</a>, <a href="https://www.iamivan.net/tag/jquery1-9-1/" title="jquery1&period;9&period;1">jquery1&period;9&period;1</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>jQuery 1.9.1源码分析系列（十五）动画处理之缓动动画核心Tween_jquery的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1NA2op.html" rel="bookmark">jQuery 1&period;9&period;1源码分析系列（十五&rpar;之动画处理&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先需要有队列(queue)的基本知识.见上一章. 相关教程:jQuery下的动画处理总结: http://www.jb51.net/article/42000.htm jQuery 1.9.1源码分析系列(十五)动画处理之缓动动画核心Tween  :http://www.jb51.net/article/75821.htm a.动画入口jQuery.fn.animate函数执行流程详解 ------------------------------------------------------			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zV7VQlb.html" rel="bookmark">jQuery 1&period;9&period;1源码分析系列（十四）之常用jQuery工具&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了给下一章分析动画处理做准备,先来看一下一些工具.其中队列工具在动画处理中被经常使用. jQuery.fn. queue(([ queueName ] [, newQueue ]) || ([ queueName ,] callback ))(获取或设置当前匹配元素上待执行的函数队列. 如果当前jQuery对象匹配多个元素:获取队列时,只获取第一个匹配元素上的队列:设置队列(替换队列.追加函数)时,则为每个匹配元素都分别进行设置.如果需要移除并执行队列中的第一个函数,请使用dequeue()函			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr2eRxM.html" rel="bookmark">jQuery 1&period;9&period;1源码分析系列（十三）之位置大小操作&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先给大家展示谢 jQuery.fn.css (propertyName [, value ]| object )(函数用于设置或返回当前jQuery对象所匹配的元素的css样式属性值.如果需要删除指定的css属性,请使用该函数将其值设为空字符串(&quot;&quot;) 注意:1.如果省略了value参数,则表示获取属性值:如果指定了该参数,则表示设置属性值.2.css()函数的所有&quot;设置&quot;操作针对的是当前jQuery对象所匹配的每一个元素:所有&quot;读取&quot;操作只针对			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXKV0yM.html" rel="bookmark">Jquery 1&period;9&period;1源码分析系列（十二）之筛选操作&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				废话不多说了直接奔入主题了. jQuery.fn.find( selector ) find接受一个参数表达式selector:选择器(字符串).DOM元素(Element).jQuery对象.分两种情况处理: 第一种,如果传入的参数是非字符串,则先通过jQuery选择器将selector查找出来,然后过滤出包含于当前jQuery对象所匹配的元素的节点. if ( typeof selector !== &quot;string&quot; ) { self = this; return this.pus			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bj8gwNp.html" rel="bookmark">jQuery 1&period;9&period;1源码分析系列（十）事件系统之主动触发事件和模拟冒泡处理&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				发现一个小点,先前没有注意的 stopPropagation: function() { var e = this.originalEvent; ... if ( e.stopPropagation ) { e.stopPropagation(); } jQuery重载stopPropagation函数调用的本地事件对象的stopPropagation函数阻止冒泡.也就是说,阻止冒泡的是当前节点,而不是事件源. 说到触发事件,我们第一反应是使用$(...).click()这种方式触发click事			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr3NKM.html" rel="bookmark">Jquery1&period;9&period;1源码分析系列（十五）动画处理之外篇&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				a.动画兼容Tween.propHooks Tween.propHooks提供特殊情况下设置.获取css特征值的方法,结构如下 Tween.propHooks = { _default: { get: function(){...}, set: function(){...} }, scrollTop: { set: function(){...} } scrollLeft: { set: function(){...} } } Tween.propHooks.scrollTop 和Tween.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z44AeLz.html" rel="bookmark">Jquery1&period;9&period;1源码分析系列（六）延时对象应用之jQuery&period;ready&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				还记不记得jQuery初始化函数jQuery.fn.init中有这样是一个分支 //document ready简便写法$(function(){-}) } else if ( jQuery.isFunction( selector ) ) { return rootjQuery.ready( selector ); } 所以$(fn)===$(document).ready(fn). 来看一下jQuery.fn.ready的源码 ready: function( fn ) { // Add t			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrNZep.html" rel="bookmark">jQuery-1&period;9&period;1源码分析系列（十）事件系统之事件包装&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在上篇文章给大家介绍了jQuery-1.9.1源码分析系列(十)事件系统之事件体系结构,本篇继续给大家介绍jquery1.9.1源码分析系列相关知识,具体内容请看下文吧. 首先需要明白,浏览器的原生事件是只读的,限制了jQuery对他的操作.举个简单的例子就能明白为什么jQuery非要构造一个新的事件对象. 在委托处理中,a节点委托b节点在a被click的时候执行fn函数.当事件冒泡到b节点,执行fn的时候上下文环境需要保证正确,是a节点执行了fn而非b节点.如何保证执行fn的上下文环境是a节点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxEO0yp.html" rel="bookmark">jQuery-1&period;9&period;1源码分析系列（十一）DOM操作续之克隆节点&lowbar;jquery</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么情况下使用到克隆节点? 我们知道在对DOM操作过程中如果直接使用节点会出现节点随操作而变动的情况.比如对节点使用.after/.before/.append等方法后,节点被添加到新的地方,原来的位置上的节点被移除了.有的时候需要保留原来位置上的节点,仅仅是需要一个副本添加到对应位置,这个时候克隆就有了使用场景. jQuery.fn.clone克隆当前匹配元素集合的一个副本,并以jQuery对象的形式返回. 你还可以指定是否复制这些匹配元素(甚至它们的子元素)的附加数据( data()函数 )			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB08kp.html" rel="bookmark" class="title">让网页超链接拥有多姿多彩的下划线</a>
					<div>
						链接|网页 CSS本身没有直接提供变换HTML链接下划线的功能,但只要运用一些技巧,我们还是可以让单调的网页链接下划线变得丰富多彩. 一.基本原理 首先,自定义HTML链接下划线的第一步是创建一个图形 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OMyl84b.html" rel="bookmark" class="title">解密QQ号的队列算法</a>
					<div>
						新学期开始了,小哈是小哼的新同桌(小哈是个小美女哦~),小哼向小哈询问QQ号,小哈当然不会直接告诉小哼啦,原因嘛你懂的.所以小哈给了小哼一串加密过的数字,同时小哈也告诉了小哼解密规则.规则是这样的:首 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLQBGb.html" rel="bookmark" class="title">Win8&period;1系统开机总是闪一下才进入桌面怎么解决</a>
					<div>
						  Win8.1系统开机总是闪一下才进入桌面的解决方法. 方法如下: 1.按Win+R键,打开运行,输入regedit,点击确定; 2.在注册表编辑器界面中,依次展开到HKEY_CURRENT_USE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN1lwM.html" rel="bookmark" class="title">浅谈javascript中this在事件中的应用</a>
					<div>
						 这篇文章主要介绍了浅谈javascript中this在事件中的应用实例,非常有助于我们对this关键字的理解,这里推荐给大家.     this关键字在javascript中是非常强大的,但是如果你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQNW5KM.html" rel="bookmark" class="title">三段练习开始上手Photoshop</a>
					<div>
						  「直出 JPG = 真摄影」这个概念显然是有问题,因为那只是把成像的工作,交给相机的出厂设定而已.但是即使对后期没有抗拒心,不少摄影新手依然由于Photoshop功能过于强大.介面复杂,结果因恐惧 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRw2yGp.html" rel="bookmark" class="title">测试博客园Markdown编辑器</a>
					<div>
						1.支持任务列表 [X] 熟悉公司开发环境 [X] 了解公司产品线 [ ] 前端框架的搭建 [ ] Git命令行的学习和使用 GitHub中的Markdown语法格式支持,使用&quot;- [X]& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1EY59M.html" rel="bookmark" class="title">简化通知中心的使用</a>
					<div>
						简化通知中心的使用     说明 1. 简化通知中心,笔者曾经实现过不需要移除的通知中心,基于弱引用集合(相对于强引用集合如NSArray,NSDictionary等)编写,本例子并无太多新意 2.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqAqlRM.html" rel="bookmark" class="title">Android TextView 实现文字大小不同和文字颜色不同</a>
					<div>
						效果图如下: 关键代码如下: [java] view plaincopy StringBuffer sb = new StringBuffer();                   if(day  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw8NEp.html" rel="bookmark" class="title">服务器端JSON数据或者xml数据如何存放和设置</a>
					<div>
						问题描述 服务器端JSON数据或者xml数据如何存放和设置 本人初学,正在做关于手机app版本升级这块,手机app要从网上得到app version信息,这就需要用到JSON或者xml.现在问题是我知 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydKElb.html" rel="bookmark" class="title">关于QT installer 菜鸟不明白求解释 在线等&period;&period;&period;&period;&period;</a>
					<div>
						问题描述 关于QT installer 菜鸟不明白求解释 在线等..... 代码如下.代码本身没有问题.就是有几个不明白的地方.&quot;ADD&quot; &quot;/V&quot;&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4033qz.html" rel="bookmark" class="title">ARC模式下的循环引用引起内存泄漏</a>
					<div>
						自从iOS 5时代自动引用计数(Automatic Reference Counting)技术发布,Cocoa工程师们才扔下了内存管理的包袱,从此在Objective-C修行道路上的一座大山被削平.然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPBOoDb.html" rel="bookmark" class="title">下拉菜单-求php两个下拉列表联动解决办法&period;</a>
					<div>
						问题描述 求php两个下拉列表联动解决办法. 选择科室后,对应员工姓名根据选择的科室获取,怎么做到. 两个列表的代码: ``` echo &quot;-请选择-??&quot;; &lt;?php @ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRG32p.html" rel="bookmark" class="title">系统好几次到下午5点就卡死，连不上数据库</a>
					<div>
						问题描述 现在有个bs系统,主要功能就是分角色处理工单表,工单在各个角色之间流程,从派单.接单一直到业务结束操作.每天有四五百个单子.使用的是.net,数据库是sql2005,ie8浏览器.使用过程中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRAZ3b.html" rel="bookmark" class="title">正确认识百度权重的误区</a>
					<div>
						对于百度权重,很多人存在一定的误区,百度权重其实不是百度官方给出的定义,真正的百度权重理解是某些站长工具模拟百度算法,通过关键词排名.域名年龄·http://www.aliyun.com/zixun/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRY6Bb.html" rel="bookmark" class="title">class-用serialport类写的串口助手在接受到4K左右的数据时会发生丢包现象，怎么解决</a>
					<div>
						问题描述 用serialport类写的串口助手在接受到4K左右的数据时会发生丢包现象,怎么解决 用serialport类写的串口助手在接受到4K左右的数据时会发生丢包现象,接收数据发生丢包现象的原因是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnryVM.html" rel="bookmark" class="title">windows下objective-c的cocoa框架编程，可以有图形界面哟</a>
					<div>
						先配置windows下的objective-c的开发环境 去http://ftpmain.gnustep.org/pub/gnustep/binaries/windows/下载下面几个包,注意版本,我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeK45M.html" rel="bookmark" class="title">如何为企业选择合适的数据集成工具？</a>
					<div>
						企业产生和收集的数据量日渐增长,随之而来的是对这些数据进行集成需求的增长,可以帮助IT团队简化并管理这一流程的数据集成软件应运而生.但是产品类型如此丰富,对你的企业来说哪些数据集成工具才是最佳之选呢? ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvnvqVM.html" rel="bookmark" class="title">谈到电影，我们收获了什么</a>
					<div>
						0.绪论 本文打算写个三部曲.想想还是算了,毕竟工作这么忙. 王小波说过,一个人只拥有此生此世是不够的,他还应该拥有诗意的世界. 现在的年轻人喜爱电影,而这个第七门艺术作为一种生活方式,渗透到了我们每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xJ0db.html" rel="bookmark" class="title">PgSQL &CenterDot; 最佳实践 &CenterDot; 从 MaxCompute &lpar;ODPS&rpar; 迁移数据到 HybridDB</a>
					<div>
						title: PgSQL · 最佳实践 · 从 ODPS 迁移数据到 HybridDB author: 曾文旌(义从) 背景 最近,不少用户在尝试使用 HybridDB 的过程中,询问我们如何把之前在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baBelqM.html" rel="bookmark" class="title">struts 怎样遍历list</a>
					<div>
						问题描述 从值栈中向jsp传递页面 在jsp页面中遍历list&lt;s:iteratorvalue=&quot;deptlist&quot;var=&quot;dept&quot;&gt;&lt;s ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkANZyb.html" rel="bookmark" class="title">《精解Windows8》&mdash;&mdash;第1章　超越传统     1&period;1革命性的Windows操作系统</a>
					<div>
						第1章 超越传统 革命性的Windows操作系统 告别开始按钮进入&quot;开始&quot;屏幕时代 触控用户界面的革命--动态磁贴 支持ARM硬件体系 Windows 8的改变可谓是翻天覆地.连微 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj87jmp.html" rel="bookmark" class="title">分析称百度处于良好发展期 付费搜索潜力巨大</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 美国知名投资网站The Motle ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze013Np.html" rel="bookmark" class="title">上传到空间错了！！！</a>
					<div>
						问题描述 com.microsoft.sqlserver.jdbc.SQLServerException:用户'showproduct'登录失败.atcom.microsoft.sqlserver.j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7rKjM.html" rel="bookmark" class="title">如何辨别二手返修板卡&lowbar;硬件维护</a>
					<div>
						近日小编在逛电脑市场的时候,发现有很多的二手货.返修货或公包货在市场里.特别是太平洋一期和二期的三楼,更加是这些产品的聚集地.为了让各位网友不上当受骗,小编根据自己的经验为大家提供一些如何鉴别二手货. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9j6jgp.html" rel="bookmark" class="title">NXP推出Icode DNA芯片，助力产品防伪鉴定</a>
					<div>
						近日,NXP的Icode系列高频13.56MHz RFID标签IC增加了一款新产品Icode DNA芯片. 和NXP一年前推出的Ucode DNA UHF芯片类似,Icode DNA也支持高级加密标准 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmqaLp.html" rel="bookmark" class="title">即将被281亿个传感器包围，你却还没弄懂物联网技术？</a>
					<div>
						&quot;物联网这三个字听起来很简单,却包含了很广的应用范围和丰富的内容.实际上,我们身边的门禁卡.公交卡.二代身份证.条形码.二维码.智能手环等等都是物联网的一部分,所以物联网的技术并不是新出现的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mrvw2xM.html" rel="bookmark" class="title">中科联想身份认证云服务联合实验室在北京揭牌</a>
					<div>
						中国科学院自动化研究所与联想(北京)有限公司联合成立的&quot;中科联想身份认证云服务联合实验室&quot;在自动化所揭牌. 记者26日从中国科学院自动化研究所获悉,该所与联想(北京)有限公司联合成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgPwX3p.html" rel="bookmark" class="title">动态令牌的服务器有哪些？</a>
					<div>
						问题描述 知道的应该有RSA的ACEServer,IBM好像有一个叫RTF的server,还是叫啥.有木有谁知道还有哪些主流的tokenserver???多谢了~					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4YDJ8b.html" rel="bookmark" class="title">网络营销中推广或网站的效果评估参数</a>
					<div>
						网络营销里面牵扯到对推广效果的评估(主要指对网站访问来说),会用到很多概念:如访问用户,流量,访问量,访问指标,访问来源,广告效果分析,数据统计分析等,这篇文章介绍下这些概念,以期对广告主,企业管理者 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bByw0dz.html" rel="bookmark" class="title">ios 嵌套html5网页，&amp;amp&semi;amp&semi;lt&semi;input type&equals;&amp;amp&semi;amp&semi;quot&semi;file&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;gt&semi;。在ipad中选择打开相机照相后，页面刷新了</a>
					<div>
						问题描述 ios嵌套html5网页,&lt;inputtype=&quot;file&quot;&gt;.在ipad中选择打开相机照相后,页面刷新了.在ipad浏览器中直接浏览就可以获得图片,网页也不 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
